#!/bin/bash

# Display a notification about script completion
cmd notification post -S bigtext -t 'notification' 'Tag' '🚀 installing performance tweak wait & enjoy!! 🎉' > /dev/null 2>&1
echo ""
echo ""
# pkg

echo "██████╗ ███████╗██████╗ ███████╗"
echo "██╔══██╗██╔════╝██╔══██╗██╔════╝"
echo "██████╔╝█████╗  ██████╔╝█████╗  "
echo "██╔═══╝ ██╔══╝  ██╔══██╗██╔══╝  "
echo "██║      ███████╗██║  ██║██║     "
echo "╚═╝     ╚══════╝╚═╝  ╚═╝╚═╝     "
sleep 2
echo "
_________________ __________ _______________  
7  _  77     77  V  77  77  V  77     77    \ 
|    _||  ___!|  |  ||  ||  |  ||  ___!|  7  |
|  _ \ |  __|_|  !  ||  ||  !  ||  __|_|  |  |
|  7  ||     7|     ||  ||     ||     7|  !  |
!__!__!!_____!!_____!!__!!_____!!_____!!_____!
                                              
"

# Display device information
echo ""
echo "🔍📱 Device Information"
echo "-----------------------"
echo "• Baseband Version  ➜ $(getprop gsm.version.baseband)"
sleep 0.1
echo "• Kernel            ➜ $(uname -r)"
sleep 0.1
echo "• Android SDK       ➜ $(getprop ro.build.version.sdk)"
sleep 0.1
echo "• Android Version   ➜ $(getprop ro.build.version.release)"
sleep 0.1
echo "• Device Model      ➜ $(getprop ro.product.model)"
sleep 0.1
echo "• Brand             ➜ $(getprop ro.product.brand)"
sleep 0.1
echo "• Model             ➜ $(getprop ro.product.model)"
sleep 0.1
echo "• Product           ➜ $(getprop ro.build.product)"
sleep 0.1
echo "• Hardware          ➜ $(getprop ro.hardware)"
sleep 0.1
echo "• GPU               ➜ $(getprop ro.opengles.version)"
sleep 0.1
echo "• CPU               ➜ $(getprop ro.product.cpu.abi)"
sleep 0.1
echo "• Build             ➜ $(getprop ro.build.description)"
sleep 0.1
echo ""
echo "⚠️ Important: do with you own risk!."
echo "⚠️ Use this info as a foundation for precise tweaks."
echo "⚠️ Verify compatibility before modifying for best results."
echo "if you use any part in my module please give credit🙏"

echo ""
echo "⚙️ Tweak Development ⚙️"
echo "---------------------"
echo "• Developers: @reljawa" 
echo "• Credits: @natt_0220"
echo "• Status : up to date"
echo ""
echo "• Version 5.9 revived"
echo ""
echo "Installing performance"
echo ""
sleep 1

# Function to set system properties
properties=(
# other:
"debug.composition.type c2d"


# buffers:
"debug.gpu.sync_buffer_slot 1"
"debug.gpu.use_gl_draw_arrays true"
"debug.hwui.flush_old_buffers.rate 0.7"


# hwui:
"debug.hwui.use_smart_batching true"
"debug.hwui.drawengine.texture.type surfacetexture"
"debug.hwui.renderer.texture surfacetexture"
"debug.hwui.thread_scheduler.type performance"
"debug.renderthread.wakeup_ms 0"
"debug.dls.weight 100"
"debug.power.no_overide_supported 0"
"debug.hwui.ffpe true"
"debug.hwui.layer_cache_key_hashing true"
"debug.hwui.renderengine.backend skiagpu"
"debug.qti.am.resource.type super-large"
"debug.hwui.renderer.buffer dynamic-loadmulticore"
"debug.art.threads 4"
"debug.dex2oat.threads 4"
"debug.hwui.use_empty_frame 1"
"debug.hwui.call_triple_frame true"
"debug.sf.vblank_presentation 1"
"debug.egl.deferred_request_generation 1"
"debug.hwui.glsl_shader_enable_spirv 1"

# cpu:
"debug.cpu.driver_use_multicore true"
"debug.cpu_burst_perf_factor 0.7"
"debug.cpu_core_ctl_active 1"
"debug.cpu_core_ctl_busy_down_thres 35"
"debug.cpu_core_ctl_busy_up_thres 70"
"debug.cpu_core_ctl_max_cores 8"
"debug.cpu_core_ctl_offline_delay_ms 500"
"debug.cpu_efficiency 1.0"
"debug.gpuprio 7"
"debug.cpu.cpu_ctrl.system-background.cpus 1,2"
"debug.cpuprio 7"
"debug.thread.boost_on_input 1"
"debug.cpu_core_ctrl_hispeed_load 80"

# powersaver:
"debug.powersaver.ignore_adaptive_battery true"

# disable un lock threads
"debug.hwui.use_main_thread true"
"debug.hwui.disable_thread_bundle false"
"debug.hwui.disable_functor_thread false"
"debug.hwui.allow_rendering_without_context true"
"debug.hwui.msaa_composition false"

#gpu:
"debug.sf.latch_unlocked 1"


# big little beta:
"debug.little_cpu_count 1"
"debug.big_cpu_count 7"
"debug.big_core_threshold 40"
"debug.cpu_big_cluster_suspended 0"
"debug.cpu_little_cluster_suspended 1"
"debug.cpu_core_ctl_max_cores 8"
"debug.cpu_little_cluster_suspended 1"
"debug.cpu_core_ctl_offline_delay_ms 500"
"debug.cluster_little-set_his_speed $(cat /sys/devices/system/cpu/cpu1/cpufreq/cpuinfo_max_freq)"
"debug.cluster_big-set_his_speed $(cat /sys/devices/system/cpu/cpu1/cpufreq/cpuinfo_max_freq)"
  )

success_count=0
failure_count=0

for command in "${properties[@]}"; do
    if setprop $command >/dev/null 2>&1; then
        success_count=$((success_count + 1))
    else
        failure_count=$((failure_count + 1))
        failed_commands+=("$command")
    fi
done

echo "Setting system properties..."
sleep 0.5

echo "• Total commands apply successfully: $success_count"
echo "• Total commands failed to apply: $failure_count"?
echo ""

# Main script starts here

# Global settings

global_settings=(
"ram_expand_size 6144000"
"hardwareAccelerated true"
"storage_preload 1"
"thread_priority high"
"foreground_mem_priority high"
"battery_tip_constans app_restriction_enabled false"
)

success_count=0
failure_count=0

for command in "${global_settings[@]}"; do
    if settings put global $command >/dev/null 2>&1; then
        success_count=$((success_count + 1))
    else
        failure_count=$((failure_count + 1))
        failed_commands+=("$command")
    fi
done

echo "Apply Global Settings..."
sleep 1

echo "• Total commands apply successfully: $success_count"
echo "• Total commands failed to apply: $failure_count"
echo ""

# Secure settings

secure_settings=(
"multi_press_timeout 180"
"long_press_timeout 180"
)

success_count=0
failure_count=0

for command in "${secure_settings[@]}"; do
    if settings put secure $command >/dev/null 2>&1; then
        success_count=$((success_count + 1))
    else
        failure_count=$((failure_count + 1))
        failed_commands+=("$command")
    fi
done

echo "Apply Secure Settings..."
sleep 1

echo "• Total commands apply successfully: $success_count"
echo "• Total commands failed to apply: $failure_count"
echo ""

# System Table

system_settings=(
)

success_count=0
failure_count=0

for command in "${system_settings[@]}"; do
    if settings put system $command >/dev/null 2>&1; then
        success_count=$((success_count + 1))
    else
        failure_count=$((failure_count + 1))
        failed_commands+=("$command")
    fi
done

echo "Apply System Settings..."
sleep 1

echo "• Total commands apply successfully: $success_count"
echo "• Total commands failed to apply: $failure_count"
echo ""

# Cmd command

cmd_setrings=(
"power set-fixed-performance-mode-enabled true"
"power set-adaptive-power-saver-enabled false"
"activity kill-all"
)

success_count=0
failure_count=0

for command in "${cmd_setrings[@]}"; do
    if cmd $command >/dev/null 2>&1; then
        success_count=$((success_count + 1))
    else
        failure_count=$((failure_count + 1))
        failed_commands+=("$command")
    fi
done

echo "Please wait a moment..."
sleep 1

echo "• Total commands apply successfully: $success_count"
echo "• Total commands failed to apply: $failure_count"
echo ""

sleep 1
echo ""
echo "All tweaks successfully installed [✓]"
echo ""
echo ""
echo "🚀 performance tweak successfuly installed"
echo "🔥 Push Your Limits, Elevate Your Experience!"
echo "🙏 Thanks for choosing Tweak Development. Game on!"
echo ""
sleep 1

echo ""

echo "   __|  |  |  __|   __|  __|   __|    | "
echo " \__ \  |  | (     (     _|  \__ \   _| "
echo " ____/ \__/ \___| \___| ___| ____/   _) "
                                        
echo""
cmd notification post -S bigtext -t 'notification' 'Tag' '🚀 succes installing performance tweak enjoy!! 🎉' > /dev/null 2>&1
echo " info : prepare open telegram channel don't panic..."
sleep 2
am start -a android.intent.action.VIEW -d https://t.me/Youngupdatesource >/dev/null 2>&1 & >/dev/null 2>&1
echo "done..."